package pathgame.gameplay;

import me.hammerle.snuviengine.api.Engine;

public class EscMenu
{

    public enum EscMenuButtons
    {
        CONTINUE, MAINMENU, EXIT
    }
    private EscMenuButtons activeButton = EscMenuButtons.CONTINUE;

    public void tick(Gamestate gamestate)
    {
     
        if(Keys.UP_KEY.isDown() && Keys.UP_KEY.getTime() == 1 || (Keys.UP_KEY.getTime() >= 20 && Keys.UP_KEY.getTime() % 5 == 1))
        {
            
            activeButton = getPrevButton(activeButton);
            System.out.println(activeButton);
        }
        else if(Keys.DOWN_KEY.isDown() && Keys.DOWN_KEY.getTime() == 1 || (Keys.DOWN_KEY.getTime() >= 20 && Keys.DOWN_KEY.getTime() % 5 == 1))
        {
            activeButton = getNextButton(activeButton);
            System.out.println(activeButton);
        }
        else if(Keys.CONFIRM_KEY.isDown() && Keys.CONFIRM_KEY.getTime() == 1)
        {
            if(activeButton.equals(EscMenuButtons.EXIT))
            {
                Engine.stop();
            }
            else if(activeButton.equals(EscMenuButtons.CONTINUE))
            {
                gamestate.setState(Gamestates.GAMEPLAY);
            }
            else if(activeButton.equals(EscMenuButtons.MAINMENU))
            {
                gamestate.setState(Gamestates.MAINMENU);
            }
        }
    }

    public EscMenuButtons getActiveButton()
    {
        return activeButton;
    }

    public boolean isActiveButton(EscMenuButtons button)
    {
        return activeButton.equals(button);
    }

    protected EscMenuButtons getNextButton(EscMenuButtons e)
    {
        int index = e.ordinal();
        int nextIndex = index + 1;
        EscMenuButtons[] btns = EscMenuButtons.values();
        nextIndex %= btns.length;
        return btns[nextIndex];
    }

    protected EscMenuButtons getPrevButton(EscMenuButtons e)
    {
        int index = e.ordinal();
        EscMenuButtons[] btns = EscMenuButtons.values();
        int nextIndex = index + btns.length - 1;
        nextIndex %= btns.length;
        return btns[nextIndex];
    }
}
